//+------------------------------------------------------------------+
//|                                                      Impulse.mq5 |
//|                              Copyright  2016, Vladimir Karputov |
//|                                           http://wmua.ru/slesar/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016, Vladimir Karputov"
#property link      "http://wmua.ru/slesar/"
#property version   "1.00"
#property description "Analysis of tick stream. The expectation of impulse"
#include <Trade\Trade.mqh>
//+------------------------------------------------------------------+
//| Version 1.00                                                     |
//|   Comparison of average for 8 ticks and average for 3 tick       |
//+------------------------------------------------------------------+
//--- global variable
CTrade my_trade;
bool     trade_is_allow=true;          // true - trade is allow
int      number_ticks=11;              // number of ticks
double   average_value_last8;          // average value for the last 8 ticks
double   average_value_last3;          // average value for the last 3 ticks
//--- input parametres

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
//EventSetTimer(60);
   trade_is_allow=true;
   average_value_last8=0.0;
   average_value_last3=0.0;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- the array that receives ticks 
   MqlTick tick_array[];
//--- requesting ticks 
   int copied=CopyTicks(Symbol(),tick_array,COPY_TICKS_ALL,0,number_ticks);
//--- if ticks are received, show the Bid and Ask values on the chart   
   if(copied>0)
     {
      if(copied==number_ticks)
        {
         //+------------------------------------------------------------------+
         //| Point()=0.00001;                                                 |
         //| tick_array[0].time              =2016.02.01 08:00:25;            |
         //| tick_array[0].bid               =1.00150                         |
         //| tick_array[number_ticks-1].time =2016.02.01 08:00:55;            |
         //| tick_array[number_ticks-1].bid  =1.00231                         |
         //| 1.00231-1.00150=0,00081; 0,00081/0.00001=81                      |
         //+------------------------------------------------------------------+
         string text="";
         for(int i=0;i<number_ticks-3;i++)
           {
            average_value_last8+=tick_array[i].bid;
            text+=" "+IntegerToString(i);
           }
         text+="\n";
         average_value_last8/=8;
         for(int j=number_ticks-3;j<number_ticks;j++)
           {
            average_value_last3+=tick_array[j].bid;
            text+=" "+IntegerToString(j);
           }
         text+="\n";
         average_value_last3/=3;
         Comment(text,"aver8=",average_value_last8,"; \naver3=",average_value_last3);
        }
      else
         Print(copied,"!=",number_ticks);
     }
   else // report an error that occurred when receiving ticks 
     {
      Comment("Ticks could not be loaded. GetLastError()=",GetLastError());
     }
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---

  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---

  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction &trans,
                        const MqlTradeRequest &request,
                        const MqlTradeResult &result)
  {
//---

  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
//| TesterInit function                                              |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
//---

  }
//+------------------------------------------------------------------+
//| TesterPass function                                              |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
//---

  }
//+------------------------------------------------------------------+
//| TesterDeinit function                                            |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
//---

  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---

  }
//+------------------------------------------------------------------+
//| BookEvent function                                               |
//+------------------------------------------------------------------+
void OnBookEvent(const string &symbol)
  {
//---

  }
//+------------------------------------------------------------------+
